#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static struct { const char *fname; const char *mapping; } FileNameMapping[] =
{
    { "Demo 1", "demo1.dmo" },
    { "Demo 2", "demo2.dmo" },
    { "Demo 3", "demo3.dmo" },
    { "Duke3D Group", "duke3d.grp" },
    { NULL, NULL }
};



static void duke_update(int pos, int total) {}
void (*cpt_update_hook)(int pos, int total) = duke_update;

void cpt_wrfile1(unsigned char *in_char, unsigned long ibytes,
                 unsigned long obytes, unsigned long blocksize,
                 int type);

void decompress(unsigned char *src, int srclen, unsigned char *dst, int dstlen, int type)
{
	extern unsigned char *out_ptr;
	
	out_ptr = dst;

	cpt_wrfile1(src, srclen, dstlen, type, 0x1fff0);
}

int main(int argc, char *argv[])
{
	FILE *fp;
	int len;
	unsigned char *buf;
	unsigned char *dest;
	int i, j, pos;
	int namelen;
	int i1, i2, i3, i4, i5;
	int i6, i7, i8, i9, i10;
	char *name;
	
	(void) argc;
	(void) argv;
		
	fp = fopen("Installer", "rb");
	if (fp == NULL) {
		fprintf(stderr, "Could not open installer file\n");
		exit(EXIT_FAILURE);
	}
	
	fseek(fp, 0, SEEK_END);
	len = ftell(fp);
	fseek(fp, 0, SEEK_SET);
	
	buf = (unsigned char *)malloc(len);
	if (buf == NULL) {
		fprintf(stderr, "Could not allocate %d bytes\n", len);
		exit(EXIT_FAILURE);
	}
	
	fread(buf, 1, len, fp);
	
	fclose(fp);
	
	pos = (17 * 64) + 12; //885;
	for (j = 0; j < 1; j++) {
        int q = 0;
        const char *RealName = NULL;

        printf("record start pos: %d\n", pos);

        namelen = buf[pos];
        if (namelen > 128)
            namelen -= 128;

		printf("Filename len: %d\n", namelen);
	
		namelen++;
		name = (char *)malloc(namelen);
		
		pos++;
		for (i = 0; i < namelen-1; i++) {
			name[i] = buf[pos+i];
		}
		name[i] = 0;
		
		printf("Filename: %s\n", name);

        for (q = 0; FileNameMapping[q].fname != NULL; q++)
        {
            if (strcmp(name, FileNameMapping[q].fname) == 0)
            {
                RealName = FileNameMapping[q].mapping;
                break;
            }
        }

		pos += namelen-1;
		
		pos += 1; /* 0x01 ??? */
		
		/* offset */
		i4 = (buf[pos+0]<<24)|(buf[pos+1]<<16)|(buf[pos+2]<<8)|(buf[pos+3]<<0);
		printf("File offset for compressed data: %d\n", i4);
		
		pos += 4;
		
		printf("Type?: %c%c%c%c\n", buf[pos+0],buf[pos+1],buf[pos+2],buf[pos+3]);
		
		/* type */
		pos += 4; /* "data" */
		
		/* creator? */
		printf("Creator?: %c%c%c%c\n", buf[pos+0],buf[pos+1],buf[pos+2],buf[pos+3]);
		pos += 4; /* "Duke" */
		
		i6 = (buf[pos+0]<<24)|(buf[pos+1]<<16)|(buf[pos+2]<<8)|(buf[pos+3]<<0);
		pos += 4; 
		
		i7 = (buf[pos+0]<<24)|(buf[pos+1]<<16)|(buf[pos+2]<<8)|(buf[pos+3]<<0);
		pos += 4;
		
		i8 = (buf[pos+0]<<8)|(buf[pos+1]<<0);
		pos += 2;
		
		i9 = (buf[pos+0]<<24)|(buf[pos+1]<<16)|(buf[pos+2]<<8)|(buf[pos+3]<<0);
		pos += 4;
		
		i10 = (buf[pos+0]<<8)|(buf[pos+1]<<0);
		pos += 2;
	/*	
		printf("Creation date: %d\n", i6);
		printf("Modification date: %d\n", i7);
	*/
		printf("finder flags?: %04X\n", i8);
		printf("File CRC?: %08X\n", i9);
		printf("cptFlags: %02X\n", i10);
		
		printf("File is %spassword protected.\n",
			(i10 & 1) ? "" : "not ");
		printf("rsrc is %s compressed.\n",
			(i10 & 2) ? "rle/lzh" : "rle");
		printf("data is %s compressed.\n",
			(i10 & 4) ? "rle/lzh" : "rle");
			
		/* rsrc uncompressed size */
		i5 = (buf[pos+0]<<24)|(buf[pos+1]<<16)|(buf[pos+2]<<8)|(buf[pos+3]<<0);
		
		pos += 4;
				
		/* data uncompressed size */
		i1 = (buf[pos+0]<<24)|(buf[pos+1]<<16)|(buf[pos+2]<<8)|(buf[pos+3]<<0);
		pos += 4;
		
		/* rsrc compressed size */
		i2 = (buf[pos+0]<<24)|(buf[pos+1]<<16)|(buf[pos+2]<<8)|(buf[pos+3]<<0);
		pos += 4;
		
		/* data compressed size */
		i3 = (buf[pos+0]<<24)|(buf[pos+1]<<16)|(buf[pos+2]<<8)|(buf[pos+3]<<0);
		pos += 4;
		
		printf("rsrc size compressed: %d, uncompressed: %d\n", i2, i5);
		printf("data size compressed: %d, uncompressed: %d\n", i3, i1);
				
		printf("\n");
		
		
		if ((i1 > 0) && (RealName != NULL)) {
			dest = (unsigned char *)malloc(i1);
			
			decompress(&buf[i4], i3, dest, i1, i10 & 4);
			
			fp = fopen(RealName, "wb");
			fwrite(dest, 1, i1, fp);
			fclose(fp);
		}
			
		free(name);
	}
	
	free(buf);
	
	return 0;
}
